#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "EGPayInfo.h"
#import "EGRoleInfo.h"

#define EG_VERSION_CODE @"100"
#define EG_VERSION_NAME @"1.0.0"

#define KEY_EVENT @"KEY_EVENT"
#define KEY_INFO @"KEY_INFO"

#define KEY_ERROR_MESSAGE @"KEY_ERROR_MESSAGE"
#define KEY_ORDER_ID @"KEY_ORDER_ID"

#define KEY_SID @"key_sid"
#define KEY_USER_ID @"key_user_id"
#define KEY_TOKEN @"key_token"
#define KEY_USER_NAME @"key_user_name"
#define KEY_USER_NICKNAME @"key_user_nickname"
#define KEY_UNIX_TIME @"key_unix_time"

typedef void (^SdkCallback)(NSInteger type, NSDictionary *data);

typedef NS_ENUM(NSInteger,EG_EVENT_CODE) {
    EG_LOGIN_SUCCESS = 1,
    EG_LOGIN_FAILED = 2,
    EG_LOGOUT_SUCCESS = 3,
    EG_PAY_SUCCESS = 4,
    EG_PAY_FAILED = 5,
    EG_PAY_CANCEL = 6,
    EG_EXIT_SUCCESS = 7
};

@interface EGUSDK : NSObject

//（必接）初始化
+ (void)initWithCallback:(SdkCallback)callback;
//（必接）登录
+(void)login;
//（必接）支付
+(void)pay:(EGPayInfo *)payInfo;
//（必接）进入游戏时，提交角色信息
+(void)onEnterGame:(EGRoleInfo *)roleInfo;
//（必接）游戏角色信息变化时，提交角色信息
+(void)onRoleInfoChange:(EGRoleInfo *)roleInfo;
//（选接）退出登录
+(void)logout;
//（选接）退出游戏
+(void)exit:(EGRoleInfo *)roleInfo;

//（必接）AppDelegate相关回调
+ (void)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions;
+ (void)applicationWillResignActive:(UIApplication *)application;
+ (void)applicationDidEnterBackground:(UIApplication *)application;
+ (void)applicationWillEnterForeground:(UIApplication *)application;
+ (void)applicationDidBecomeActive:(UIApplication *)application;
+ (void)applicationWillTerminate:(UIApplication *)application;
+ (void)application:(UIApplication *)application didRegisterForRemoteNotificationsWithDeviceToken:(NSData *)deviceToken;
+ (void)application:(UIApplication *)application didFailToRegisterForRemoteNotificationsWithError:(NSError *)error;
+ (UIInterfaceOrientationMask)application:(UIApplication *)application supportedInterfaceOrientationsForWindow:(nullable UIWindow *)window;
+ (void)application:(UIApplication *)application handleOpenURL:(NSURL *)url;
+ (void)application:(UIApplication *)application openURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation;
+ (void)application:(UIApplication *)app openURL:(NSURL *)url options:(NSDictionary<NSString*, id> *)options;

@end
